void Render(Surface dst, Surface src, Rectangle rect)
{
    ColorBgra PrimaryColor = (ColorBgra)EnvironmentParameters.PrimaryColor;
    ColorBgra SecondaryColor = (ColorBgra)EnvironmentParameters.SecondaryColor;

    ColorBgra CurrentPixel;
    for (int y = rect.Top; y < rect.Bottom; y++)
    {
        for (int x = rect.Left; x < rect.Right; x++)
        {
            CurrentPixel = src[x,y];
             if ((CurrentPixel.R != PrimaryColor.R)||(CurrentPixel.G != PrimaryColor.G)||(CurrentPixel.B != PrimaryColor.B))
             {                                                                                  
                if ((CurrentPixel == SecondaryColor)||(CurrentPixel.A < 255))
                {
                CurrentPixel.A = 0;
                }
                else
                {              
                double dcsr = (CurrentPixel.R - SecondaryColor.R);
                double dcsg = (CurrentPixel.G - SecondaryColor.G);
                double dcsb = (CurrentPixel.B - SecondaryColor.B);
                double dpsr = (PrimaryColor.R - SecondaryColor.R);
                double dpsg = (PrimaryColor.G - SecondaryColor.G);
                double dpsb = (PrimaryColor.B - SecondaryColor.B);                                             
                            
                  double rar = 0;
                  double rag = 0;
                  double rab = 0;
                  if (dpsr != 0) rar =(255*(dcsr/dpsr));
                  if (dpsg != 0) rag =(255*(dcsg/dpsg));
                  if (dpsb != 0) rab =(255*(dcsb/dpsb));  
                  
                  int ra = 0;
                  if ((rar != 0)&(rag != 0)&(rab != 0))ra = (byte)((rar+rag+rab)/3);
                  if ((rar != 0)&(rag != 0)&(rab == 0))ra = (byte)((rar+rag)/2);
                  if ((rar != 0)&(rag == 0)&(rab != 0))ra = (byte)((rar+rab)/2);
                  if ((rar != 0)&(rag == 0)&(rab == 0))ra = (byte)(rar);
                  if ((rar == 0)&(rag != 0)&(rab != 0))ra = (byte)((rag+rab)/2);
                  if ((rar == 0)&(rag != 0)&(rab == 0))ra = (byte)(rag);
                  if ((rar == 0)&(rag == 0)&(rab != 0))ra = (byte)(rab);                                    
                                                                                                              
                  CurrentPixel.A = (byte)ra;                                                                                                                                                                                  
                                        
                CurrentPixel.R = (byte)PrimaryColor.R;                        
                CurrentPixel.G = (byte)PrimaryColor.G;
                CurrentPixel.B = (byte)PrimaryColor.B;
                }
             }                                                                 
            dst[x,y] = CurrentPixel;
        }
    }
}
